<?xml version="1.0" encoding="utf-8"?><!--
  ~ Copyright (C) 2019 The Android Open Source Project
  ~
  ~ Licensed under the Apache License, Version 2.0 (the "License");
  ~ you may not use this file except in compliance with the License.
  ~ You may obtain a copy of the License at
  ~
  ~      http://www.apache.org/licenses/LICENSE-2.0
  ~
  ~ Unless required by applicable law or agreed to in writing, software
  ~ distributed under the License is distributed on an "AS IS" BASIS,
  ~ WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  ~ See the License for the specific language governing permissions and
  ~ limitations under the License.
  -->
<layout xmlns:android="http://schemas.android.com/apk/res/android"
    xmlns:app="http://schemas.android.com/apk/res-auto">

    <data>

        <import type="android.view.View" />

        <import type="androidx.core.content.ContextCompat" />

        <variable
            name="viewmodel"
            type="com.example.android.architecture.blueprints.todoapp.tasks.TasksViewModel" />

    </data>


    <androidx.coordinatorlayout.widget.CoordinatorLayout
        android:id="@+id/coordinator_layout"
        android:layout_width="match_parent"
        android:layout_height="match_parent">


        <com.example.android.architecture.blueprints.todoapp.ScrollChildSwipeRefreshLayout
            android:id="@+id/refresh_layout"
            android:layout_width="match_parent"
            android:layout_height="match_parent"
            app:onRefreshListener="@{viewmodel::refresh}"
            app:refreshing="@{viewmodel.dataLoading}">

            <RelativeLayout
                android:id="@+id/tasks_container_layout"
                android:layout_width="match_parent"
                android:layout_height="match_parent"
                android:clickable="true"
                android:orientation="vertical"
                android:focusable="true">

                <LinearLayout
                    android:id="@+id/tasks_linear_layout"
                    android:layout_width="match_parent"
                    android:layout_height="match_parent"
                    android:orientation="vertical"
                    android:visibility="@{viewmodel.empty ? View.GONE : View.VISIBLE}">

                    <TextView
                        android:id="@+id/filtering_text"
                        android:layout_width="match_parent"
                        android:layout_height="wrap_content"
                        android:layout_marginLeft="@dimen/list_item_padding"
                        android:layout_marginTop="@dimen/activity_vertical_margin"
                        android:layout_marginRight="@dimen/list_item_padding"
                        android:layout_marginBottom="@dimen/activity_vertical_margin"
                        android:gravity="center_vertical"
                        android:text="@{context.getString(viewmodel.currentFilteringLabel)}"
                        android:textAppearance="@style/TextAppearance.AppCompat.Title" />

                    <androidx.recyclerview.widget.RecyclerView
                        android:id="@+id/tasks_list"
                        android:layout_width="match_parent"
                        android:layout_height="wrap_content"
                        app:layoutManager="androidx.recyclerview.widget.LinearLayoutManager"
                        app:items="@{viewmodel.items}" />
                </LinearLayout>

                <LinearLayout
                    android:id="@+id/no_tasks_layout"
                    android:layout_width="wrap_content"
                    android:layout_height="wrap_content"
                    android:layout_centerInParent="true"
                    android:orientation="vertical"
                    android:visibility="@{viewmodel.empty ? View.VISIBLE : View.GONE}">

                    <ImageView
                        android:id="@+id/no_tasks_icon"
                        android:layout_width="96dp"
                        android:layout_height="96dp"
                        android:layout_gravity="center"
                        android:src="@{ContextCompat.getDrawable(context, viewmodel.noTaskIconRes)}"
                        android:contentDescription="@string/no_tasks_image_content_description" />

                    <TextView
                        android:id="@+id/no_tasks_text"
                        android:layout_width="wrap_content"
                        android:layout_height="wrap_content"
                        android:layout_gravity="center"
                        android:layout_marginBottom="@dimen/list_item_padding"
                        android:text="@{context.getString(viewmodel.noTasksLabel)}" />
                </LinearLayout>
            </RelativeLayout>

        </com.example.android.architecture.blueprints.todoapp.ScrollChildSwipeRefreshLayout>

        <com.google.android.material.floatingactionbutton.FloatingActionButton
            android:id="@+id/add_task_fab"
            android:layout_width="wrap_content"
            android:layout_height="wrap_content"
            android:layout_margin="@dimen/fab_margin"
            android:src="@drawable/ic_add"
            app:fabSize="normal"
            app:layout_anchor="@id/refresh_layout"
            app:layout_anchorGravity="bottom|right|end"
            android:contentDescription="@string/fab_create_task_content_description" />
    </androidx.coordinatorlayout.widget.CoordinatorLayout>
</layout>

